Index: flexpart_code/fpmetbinary_mod.F90
===================================================================
--- flexpart_code/fpmetbinary_mod.F90	(revision 515b21c06ac454a3edcdd8f8fcbbaafcaa3d2291)
+++ flexpart_code/fpmetbinary_mod.F90	(revision b398fb67a4f4baa29fc8752c3bd278a6e469486e)
@@ -2381,137 +1994,1203 @@
 
 
-#ifdef RAWBIN
+            ! Get the varid , then read into scalar variable
+            ncret = nf90_inq_varid(ncid, 'nx', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nx)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'ny', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ny)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nxmin1', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nxmin1)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nymin1', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nymin1)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nxfield', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nxfield)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nuvz', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nuvz)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nwz', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nwz)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nz', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nz)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nmixz', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nmixz)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nlev_ec', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nlev_ec)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'dx', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, dx)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'dy', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, dy)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'xlon0', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, xlon0)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'ylat0', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ylat0)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'dxconst', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, dxconst)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'dyconst', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, dyconst)
+            call handle_nf90_err(ncret)
+
+
+
+
+
+
+            ! Fixed fields, static in time
+            ncret = nf90_inq_varid(ncid, 'oro', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, oro(0:nxmax-1,0:nymax-1))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'excessoro', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, excessoro(0:nxmax-1,0:nymax-1))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'lsm', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, lsm(0:nxmax-1,0:nymax-1))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'xlanduse', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, xlanduse(0:nxmax-1,0:nymax-1, 1:numclass))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'height', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, height(1:nzmax))
+            call handle_nf90_err(ncret)
+
+
+
+
+            ! 3d fields
+
+            ! Get the varid and read the variable into the array
+            ncret = nf90_inq_varid(ncid, 'uu', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, uu(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'vv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, vv(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'uupol', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, uupol(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'vvpol', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, vvpol(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'ww', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ww(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tt', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tt(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'qv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, qv(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'pv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, pv(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'rho', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, rho(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'drhodz', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, drhodz(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'clouds', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, clouds(0:nxmax-1,0:nymax-1,1:nzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tth', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tth(0:nxmax-1,0:nymax-1,1:nuvzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'qvh', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, qvh(0:nxmax-1,0:nymax-1,1:nuvzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'pplev', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, pplev(0:nxmax-1,0:nymax-1,1:nuvzmax,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'cloudsh', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, cloudsh(0:nxmax-1,0:nymax-1,cm_index))
+            call handle_nf90_err(ncret)
+
+
+
+
+            PRINT *, 'SUM(tt(0:nxmax-1, 0:nymax-1, 1:nzmax, cm_index)): ', &
+&                                        SUM(tt(0:nxmax-1,0:nymax-1,1:nzmax, cm_index))
+
+
+            PRINT *, 'SUM(clouds(0:nxmax-1, 0:nymax-1, 1:nzmax, cm_index)): ', &
+&                                        SUM(clouds(0:nxmax-1,0:nymax-1,1:nzmax, cm_index))
+
+
+
+            ! 2d fields
+
+            ! Get the varid and read the variable into the array
+            ncret = nf90_inq_varid(ncid, 'ps', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ps(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'sd', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, sd(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'msl', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, msl(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tcc', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tcc(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'u10', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, u10(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'v10', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, v10(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tt2', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tt2(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'td2', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, td2(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'lsprec', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, lsprec(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'convprec', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, convprec(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'sshf', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, sshf(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'ssr', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ssr(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'surfstr', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, surfstr(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'ustar', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ustar(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'wstar', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, wstar(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'hmix', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, hmix(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tropopause', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tropopause(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'oli', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, oli(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'diffk', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, diffk(0:nxmax-1,0:nymax-1,1,cm_index))
+            call handle_nf90_err(ncret)
+
+
+
+
+            PRINT *, 'SUM(ps(0:nxmax-1, 0:nymax-1, 1, cm_index)): ', &
+&                                        SUM(ps(0:nxmax-1,0:nymax-1,1, cm_index))
+
+            PRINT *, 'SUM(wstar(0:nxmax-1, 0:nymax-1, 1, cm_index)): ', &
+&                                        SUM(wstar(0:nxmax-1,0:nymax-1,1, cm_index))
+
+
+            ncret = nf90_inq_varid(ncid, 'vdep', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, vdep(0:nxmax-1,0:nymax-1,1:maxspec, cm_index))
+            call handle_nf90_err(ncret)
+
+
+
+
+
+            ! 1d fields
+
+            ncret = nf90_inq_varid(ncid, 'z0', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, z0(1:numclass))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'akm', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, akm(1:nwzmax))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'bkm', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, bkm(1:nwzmax))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'akz', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, akz(1:nuvzmax))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'bkz', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, bkz(1:nuvzmax))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'aknew', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, aknew(1:nzmax))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'bknew', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, bknew(1:nzmax))
+            call handle_nf90_err(ncret)
+
+
+
+            PRINT *, 'SUM(bknew(1:nzmax)): ', &
+&                                        SUM(bknew(1:nzmax))
+
+
+
+
+            ! Now the nested input grid variables
+            ! Get the compiled values that were written into the FP file, and
+            ! make sure they are equal to the current compiled values, to make
+            ! sure we are working with consistent arrays
+            ncret = nf90_inq_dimid(ncid, 'maxnests', maxnests_dimid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_inquire_dimension(ncid, maxnests_dimid, maxnests_dimname, &
+&                                                temp_maxnests)
+            call handle_nf90_err(ncret)
+            PRINT *, 'temp_maxnests: ', temp_maxnests
+
+            ncret = nf90_inq_dimid(ncid, 'nxmaxn', nxmaxn_dimid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_inquire_dimension(ncid, nxmaxn_dimid, nxmaxn_dimname, &
+&                                                temp_nxmaxn)
+            call handle_nf90_err(ncret)
+            PRINT *, 'temp_nxmaxn: ', temp_nxmaxn
+
+            ncret = nf90_inq_dimid(ncid, 'nymaxn', nymaxn_dimid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_inquire_dimension(ncid, nymaxn_dimid, nymaxn_dimname, &
+&                                                temp_nymaxn)
+            call handle_nf90_err(ncret)
+            PRINT *, 'temp_nymaxn: ', temp_nymaxn
+
+            ! Note that maxspec_dimid and numclass_dimid were checked above
+
+
+
+
+            IF ( (temp_nxmaxn == nxmaxn) .AND. (temp_nymaxn == nymaxn) .AND. &
+&                   (temp_maxnests == maxnests) ) THEN
+                CONTINUE
+            ELSE
+                PRINT *, 'Incompatible dimensions between fp file and current FLEXPART!'
+                ! PRINT *, ''
+                PRINT *, '                  FP file     Compiled FP'
+                PRINT *, 'nxmaxn:     ', temp_nxmaxn, '    ', nxmaxn
+                PRINT *, 'nymaxn:     ', temp_nymaxn, '    ', nymaxn
+                PRINT *, 'maxnests:     ', temp_maxnests, '    ', maxnests
+                STOP
+            END IF
+
+
+
+            ! Nested, scalar values (for each nest)
+            ncret = nf90_inq_varid(ncid, 'nxn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nxn(1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nyn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nyn(1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'dxn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, dxn(1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'dyn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, dyn(1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'xlon0n', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, xlon0n(1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'ylat0n', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ylat0n(1:maxnests))
+            call handle_nf90_err(ncret)
+
+
+
+            ! Nested fields, static over time
+            ncret = nf90_inq_varid(ncid, 'oron', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, oron(0:nxmaxn-1,0:nymaxn-1,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'excessoron', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, excessoron(0:nxmaxn-1,0:nymaxn-1,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'lsmn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, lsmn(0:nxmaxn-1,0:nymaxn-1,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'xlandusen', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, xlandusen(0:nxmaxn-1,0:nymaxn-1,1:numclass,1:maxnests))
+            call handle_nf90_err(ncret)
+
+
+            PRINT *, 'SUM(oron): ', SUM(oron)
+
+
+
+
+            ! 3d nested fields
+
+            ncret = nf90_inq_varid(ncid, 'uun', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, uun(0:nxmaxn-1,0:nymaxn-1,1:nzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'vvn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, vvn(0:nxmaxn-1,0:nymaxn-1,1:nzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'wwn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, wwn(0:nxmaxn-1,0:nymaxn-1,1:nzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'ttn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ttn(0:nxmaxn-1,0:nymaxn-1,1:nzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'qvn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, qvn(0:nxmaxn-1,0:nymaxn-1,1:nzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'pvn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, pvn(0:nxmaxn-1,0:nymaxn-1,1:nzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'rhon', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, rhon(0:nxmaxn-1,0:nymaxn-1,1:nzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'drhodzn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, drhodzn(0:nxmaxn-1,0:nymaxn-1,1:nzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tthn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tthn(0:nxmaxn-1,0:nymaxn-1,1:nuvzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'qvhn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, qvhn(0:nxmaxn-1,0:nymaxn-1,1:nuvzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'cloudsn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, cloudsn(0:nxmaxn-1,0:nymaxn-1,0:nzmax,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'cloudsnh', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, cloudsnh(0:nxmaxn-1,0:nymaxn-1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+
+
+
+            PRINT *, 'SUM(uun): ', SUM(uun(:,:,:,cm_index,:))
+            PRINT *, 'SUM(qvhn): ', SUM(qvhn(:,:,:,cm_index,:))
+            PRINT *, 'SUM(cloudsn): ', SUM(cloudsn(:,:,:,cm_index,:))
+
+
+
+
+            ! 2d nested fields
+            ncret = nf90_inq_varid(ncid, 'psn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, psn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'sdn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, sdn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'msln', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, msln(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tccn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tccn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'u10n', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, u10n(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'v10n', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, v10n(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tt2n', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tt2n(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'td2n', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, td2n(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'lsprecn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, lsprecn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'convprecn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, convprecn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'sshfn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, sshfn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'ssrn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ssrn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'surfstrn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, surfstrn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'ustarn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ustarn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'wstarn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, wstarn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'hmixn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, hmixn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tropopausen', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tropopausen(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'olin', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, olin(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'diffkn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, diffkn(0:nxmaxn-1,0:nymaxn-1,1,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'vdepn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, vdepn(0:nxmaxn-1,0:nymaxn-1,1:maxspec,cm_index,1:maxnests))
+            call handle_nf90_err(ncret)
+
+
+
+
+            PRINT *, 'SUM(psn): ', SUM(psn(:,:,:,cm_index,:))
+            PRINT *, 'SUM(surfstrn): ', SUM(surfstrn(:,:,:,cm_index,:))
+            PRINT *, 'SUM(vdepn): ', SUM(vdepn(:,:,:,cm_index,:))
+
+
+
+            ! Auxiliary variables for nests
+            ncret = nf90_inq_varid(ncid, 'xresoln', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, xresoln(0:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'yresoln', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, yresoln(0:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'xln', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, xln(1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'yln', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, yln(1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'xrn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, xrn(1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'yrn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, yrn(1:maxnests))
+            call handle_nf90_err(ncret)
+
+
+
+            PRINT *, 'SUM(yresoln): ', SUM(yresoln)
+            PRINT *, 'SUM(xrn): ', SUM(xrn)
+
+
+
+            ! Variables for polar stereographic projection
+            ncret = nf90_inq_varid(ncid, 'southpolemap', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, southpolemap(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'northpolemap', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, northpolemap(:))
+            call handle_nf90_err(ncret)
+
+            ! xglobal, sglobal, nglobal are LOGICAL vars, and need to be converted
+            ! to INTEGER for NetCDF storage
+            ncret = nf90_inq_varid(ncid, 'xglobal', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, temp_integer)
+            call handle_nf90_err(ncret)
+            xglobal = integer2logical(temp_integer)
+
+            ncret = nf90_inq_varid(ncid, 'sglobal', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, temp_integer)
+            call handle_nf90_err(ncret)
+            sglobal = integer2logical(temp_integer)
+
+            ncret = nf90_inq_varid(ncid, 'nglobal', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, temp_integer)
+            call handle_nf90_err(ncret)
+            nglobal = integer2logical(temp_integer)
+
+            ncret = nf90_inq_varid(ncid, 'switchnorthg', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, switchnorthg)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'switchsouthg', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, switchsouthg)
+            call handle_nf90_err(ncret)
+
+
+            PRINT *, 'SUM(northpolemap): ', SUM(northpolemap)
+            PRINT *, 'xglobal: ', xglobal
+            PRINT *, 'sglobal: ', sglobal
+            PRINT *, 'nglobal: ', nglobal
+            PRINT *, 'switchsouthg: ', switchsouthg
+
+
+
+
+            ! Variables declared in conv_mod (convection)
+            ncret = nf90_inq_varid(ncid, 'pconv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, pconv(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'dpr', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, dpr(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'pconv_hpa', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, pconv_hpa(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'ft', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, ft(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'fq', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, fq(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'sub', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, sub(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'phconv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, phconv(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'phconv_hpa', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, phconv_hpa(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tconv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tconv(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'qconv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, qconv(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'qsconv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, qsconv(:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'fmass', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, fmass(:,:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'fmassfrac', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, fmassfrac(:,:))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'cbaseflux', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, cbaseflux(0:nxmax-1,0:nymax-1))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'cbasefluxn', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, cbasefluxn(0:nxmaxn-1,0:nymaxn-1,1:maxnests))
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'psconv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, psconv)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'tt2conv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, tt2conv)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'td2conv', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, td2conv)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nconvlev', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nconvlev)
+            call handle_nf90_err(ncret)
+
+            ncret = nf90_inq_varid(ncid, 'nconvtop', ncvarid)
+            call handle_nf90_err(ncret)
+            ncret = nf90_get_var(ncid, ncvarid, nconvtop)
+            call handle_nf90_err(ncret)
+
+
+
+
+            PRINT *, 'SUM(pconv): ', SUM(pconv)
+            PRINT *, 'SUM(qconv): ', SUM(qconv)
+            PRINT *, 'SUM(fmassfrac): ', SUM(fmassfrac)
+            PRINT *, 'SUM(cbasefluxn): ', SUM(cbasefluxn)
+            PRINT *, 'tt2conv: ', tt2conv
+            PRINT *, 'nconvlev: ', nconvlev
+
+
+
+        ELSE
+            STOP 'fpio(): Illegal operation' 
+            
+        ENDIF
+    END SUBROUTINE fpio
+
+
+
+
+
+    SUBROUTINE fpio_rawbin(iounit, op, cm_index)
+        IMPLICIT NONE
+        INTEGER, INTENT(IN) :: iounit
+        CHARACTER(LEN=4), INTENT(IN) :: op        ! Operation - DUMP or LOAD
+        INTEGER, INTENT(IN) :: cm_index           ! Index of last dimension in
+                                                  ! most com_mod variables.
+                                                  ! Should be 1 or 2 
+
+
+        INTEGER :: temp_integer   ! temporary value
+
+
+        ! These are temporary variables, used in the LOAD option, for 
+        ! comparing against the current values in FLEXPART of nxmax, nymax, ...
+        INTEGER :: temp_nxmax, temp_nymax, temp_nzmax, &
+&                  temp_nuvzmax, temp_nwzmax, &
+&                  temp_maxspec, temp_numclass,&
+&                  temp_maxnests, temp_nxmaxn, temp_nymaxn, temp_preproc_fmt_str_dim
+
+        CHARACTER(LEN=PREPROC_FMT_STR_DIM) :: temp_preproc_format_version_str
+
+        CHARACTER(LEN=128) :: errmesg
+
+        INTEGER, PARAMETER :: DEF_LEVEL = 3
+
+        if (op == 'DUMP') THEN
+
+
+            ! Write the preprocessing format version string
+            !  NEED TO FILL THIS IN FOR NC4
+
+
+
+            WRITE (iounit) PREPROC_FORMAT_VERSION_STR
+
+
+            ! Write the compiled max dimensions from par_mod - these are
+            ! not meant to be reassigned during a LOAD, but used as "header"
+            ! information to provide the structure of arrays
+
+
+            WRITE (iounit) nxmax, nymax, nzmax, nuvzmax, nwzmax
+
+
+
+
+            ! Scalar values
+
+            ! Fixed fields, static in time
+
+
+
+            WRITE(iounit) oro, excessoro, lsm, xlanduse, height
+
+
+ 
+
+            ! 3d fields
+            WRITE(iounit) uu(:,:,:,cm_index)
+            WRITE(iounit) vv(:,:,:,cm_index)
+            WRITE(iounit) uupol(:,:,:,cm_index)
+            WRITE(iounit) vvpol(:,:,:,cm_index)
+            WRITE(iounit) ww(:,:,:,cm_index)
+            WRITE(iounit) tt(:,:,:,cm_index)
+            WRITE(iounit) qv(:,:,:,cm_index)
+            WRITE(iounit) pv(:,:,:,cm_index)
+            WRITE(iounit) rho(:,:,:,cm_index)
+            WRITE(iounit) drhodz(:,:,:,cm_index)
+            WRITE(iounit) tth(:,:,:,cm_index)
+            WRITE(iounit) qvh(:,:,:,cm_index)
+            WRITE(iounit) pplev(:,:,:,cm_index)
+            WRITE(iounit) clouds(:,:,:,cm_index)
+            WRITE(iounit) cloudsh(:,:,cm_index)
+
+
+
+!            PRINT *, 'SUM(tt(0:nxmax-1, 0:nymax-1, 1:nzmax, cm_index)): ', &
+!&                                        SUM(tt(0:nxmax-1,0:nymax-1,1:nzmax, cm_index))
+
+!            PRINT *, 'SUM(clouds(0:nxmax-1, 0:nymax-1, 1:nzmax, cm_index)): ', &
+!&                                        SUM(clouds(0:nxmax-1,0:nymax-1,1:nzmax, cm_index))
+
+
+
+            ! 2d fields
+            WRITE(iounit) ps(:,:,:,cm_index)
+            WRITE(iounit) sd(:,:,:,cm_index)
+            WRITE(iounit) msl(:,:,:,cm_index)
+            WRITE(iounit) tcc(:,:,:,cm_index)
+            WRITE(iounit) u10(:,:,:,cm_index)
+            WRITE(iounit) v10(:,:,:,cm_index)
+            WRITE(iounit) tt2(:,:,:,cm_index)
+            WRITE(iounit) td2(:,:,:,cm_index)
+            WRITE(iounit) lsprec(:,:,:,cm_index)
+            WRITE(iounit) convprec(:,:,:,cm_index)
+            WRITE(iounit) sshf(:,:,:,cm_index)
+            WRITE(iounit) ssr(:,:,:,cm_index)
+            WRITE(iounit) surfstr(:,:,:,cm_index)
+            WRITE(iounit) ustar(:,:,:,cm_index)
+            WRITE(iounit) wstar(:,:,:,cm_index)
+            WRITE(iounit) hmix(:,:,:,cm_index)
+            WRITE(iounit) tropopause(:,:,:,cm_index)
+            WRITE(iounit) oli(:,:,:,cm_index)
+            WRITE(iounit) diffk(:,:,:,cm_index)
+            WRITE(iounit) vdep(:,:,:,cm_index)
+
+
+
+
+            ! 1d fields
+            WRITE(iounit) z0(:)
+            WRITE(iounit) akm(:)
+            WRITE(iounit) bkm(:)
+            WRITE(iounit) akz(:)
+            WRITE(iounit) bkz(:)
+            WRITE(iounit) aknew(:)
+            WRITE(iounit) bknew(:)
+
+
+
+
+
+!            PRINT *, 'SUM(bknew(1:nzmax)): ', &
+!&                                        SUM(bknew(1:nzmax))
+
+
+
+            ! Getting ready to add in nested code
+
+            ! These are compiled max dimensions from par_mod - these are
+            ! not meant to be reassigned during a LOAD, but used as "header"
+            ! information to provide the structure of arrays
+            WRITE(iounit) nxn(:)
+            WRITE(iounit) nyn(:)
+            WRITE(iounit) dxn(:)
+            WRITE(iounit) dyn(:)
+            WRITE(iounit) xlon0n(:)
+            WRITE(iounit) ylat0n(:)
+
+            ! Nested, scalar values (for each nest)
+
+
+            ! Nested fields, static over time
+            WRITE(iounit) oron, excessoron, lsmn, xlandusen 
+
+
+!           PRINT *, 'SUM(oron): ', SUM(oron)
+
+
+
+            ! 3d nested fields
+            WRITE(iounit) uun(:,:,:,cm_index,:)
+            WRITE(iounit) vvn(:,:,:,cm_index,:)
+            WRITE(iounit) wwn(:,:,:,cm_index,:)
+            WRITE(iounit) ttn(:,:,:,cm_index,:)
+            WRITE(iounit) qvn(:,:,:,cm_index,:)
+            WRITE(iounit) pvn(:,:,:,cm_index,:)
+            WRITE(iounit) cloudsn(:,:,:,cm_index,:)
+            WRITE(iounit) cloudsnh(:,:,cm_index,:)
+            WRITE(iounit) rhon(:,:,:,cm_index,:)
+            WRITE(iounit) drhodzn(:,:,:,cm_index,:)
+            WRITE(iounit) tthn(:,:,:,cm_index,:)
+            WRITE(iounit) qvhn(:,:,:,cm_index,:)
+
+
+
+!            PRINT *, 'SUM(uun): ', SUM(uun(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(qvhn): ', SUM(qvhn(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(cloudsn): ', SUM(cloudsn(:,:,:,cm_index,:))
+
+
+
+            ! 2d nested fields
+            WRITE(iounit) psn(:,:,:,cm_index,:)
+            WRITE(iounit) sdn(:,:,:,cm_index,:)
+            WRITE(iounit) msln(:,:,:,cm_index,:)
+            WRITE(iounit) tccn(:,:,:,cm_index,:)
+            WRITE(iounit) u10n(:,:,:,cm_index,:)
+            WRITE(iounit) v10n(:,:,:,cm_index,:)
+            WRITE(iounit) tt2n(:,:,:,cm_index,:)
+            WRITE(iounit) td2n(:,:,:,cm_index,:)
+            WRITE(iounit) lsprecn(:,:,:,cm_index,:)
+            WRITE(iounit) convprecn(:,:,:,cm_index,:)
+            WRITE(iounit) sshfn(:,:,:,cm_index,:)
+            WRITE(iounit) ssrn(:,:,:,cm_index,:)
+            WRITE(iounit) surfstrn(:,:,:,cm_index,:)
+            WRITE(iounit) ustarn(:,:,:,cm_index,:)
+            WRITE(iounit) wstarn(:,:,:,cm_index,:)
+            WRITE(iounit) hmixn(:,:,:,cm_index,:)
+            WRITE(iounit) tropopausen(:,:,:,cm_index,:)
+            WRITE(iounit) olin(:,:,:,cm_index,:)
+            WRITE(iounit) diffkn(:,:,:,cm_index,:)
+            WRITE(iounit) vdepn(:,:,:,cm_index,:)
+
+
+
+!            PRINT *, 'SUM(psn): ', SUM(psn(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(surfstrn): ', SUM(surfstrn(:,:,:,cm_index,:))
+!            PRINT *, 'SUM(vdepn): ', SUM(vdepn(:,:,:,cm_index,:))
+
+
+
+
+
+            ! Auxiliary variables for nests
+            WRITE(iounit) xresoln(:)
+            WRITE(iounit) yresoln(:)
+            WRITE(iounit) xln(:)
+            WRITE(iounit) yln(:)
+            WRITE(iounit) xrn(:)
+            WRITE(iounit) yrn(:)
+
+
+
+!            PRINT *, 'SUM(yresoln): ', SUM(yresoln)
+!            PRINT *, 'SUM(xrn): ', SUM(xrn)
+
+
+
+            ! Variables for polar stereographic projection
+            WRITE(iounit) xglobal, sglobal, nglobal
+            WRITE(iounit) switchnorthg, switchsouthg
+            WRITE(iounit) southpolemap(:)
+            WRITE(iounit) northpolemap(:)
+
+
+
+
+
+!            PRINT *, 'SUM(northpolemap): ', SUM(northpolemap)
+!            PRINT *, 'xglobal: ', xglobal
+!            PRINT *, 'sglobal: ', sglobal
+!            PRINT *, 'nglobal: ', nglobal
+!            PRINT *, 'switchsouthg: ', switchsouthg
+
+            ! Variables declared in conv_mod (convection)
+            WRITE(iounit) pconv(:)
+            WRITE(iounit) phconv(:)
+            WRITE(iounit) dpr(:)
+            WRITE(iounit) pconv_hpa(:)
+            WRITE(iounit) phconv_hpa(:)
+            WRITE(iounit) ft(:)
+            WRITE(iounit) fq(:)
+            WRITE(iounit) fmass(:,:)
+            WRITE(iounit) sub(:)
+            WRITE(iounit) fmassfrac(:,:)
+            WRITE(iounit) cbaseflux(:,:)
+            WRITE(iounit) cbasefluxn(:,:,:)
+            WRITE(iounit) tconv(:)
+            WRITE(iounit) qconv(:)
+            WRITE(iounit) qsconv(:)
+            WRITE(iounit) psconv, tt2conv, td2conv
+            WRITE(iounit) nconvlev, nconvtop
+
+
+
+
+!            PRINT *, 'SUM(pconv): ', SUM(pconv)
+!            PRINT *, 'SUM(qconv): ', SUM(qconv)
+!            PRINT *, 'SUM(fmassfrac): ', SUM(fmassfrac)
+!            PRINT *, 'SUM(cbasefluxn): ', SUM(cbasefluxn)
+!            PRINT *, 'tt2conv: ', tt2conv
+!            PRINT *, 'nconvlev: ', nconvlev
+
+
+
+        ELSE IF (op == 'LOAD') THEN 
+
+            ! Read the preprocessed format version string and insure it
+            ! matches this version
+            READ (iounit) temp_preproc_format_version_str
+
+            PRINT *, 'Reading preprocessed file format version: ', &
+&                    temp_preproc_format_version_str
+            IF (TRIM(temp_preproc_format_version_str) == &
+&                                        TRIM(PREPROC_FORMAT_VERSION_STR)) THEN
+                CONTINUE
+            ELSE
+                ! PRINT *, ''  GK: causes relocation truncated to fit: R_X86_64_32
+                PRINT *, 'Inconsistent preprocessing format version'
+                PRINT *, 'Expected Version: ', PREPROC_FORMAT_VERSION_STR
+                PRINT *, 'Detected Version: ', temp_preproc_format_version_str
+                ! PRINT *, ''
+                STOP
+            END IF
+
+
+            ! Read the compiled max dimensions that were dumped from par_mod 
+            ! when creating the fp file, so that we can compare against
+            ! current FLEXPART dimensions - they need to be the same, or else
+            ! we abort.
+            READ (iounit) temp_nxmax, temp_nymax, temp_nzmax, &
+&                         temp_nuvzmax, temp_nwzmax
+
+
+
+
+
+            ! Get dimensions
+            IF ( (temp_nxmax == nxmax) .AND. (temp_nymax == nymax) .AND. &
+&                   (temp_nzmax == nzmax) .AND. &
+&                   (temp_nuvzmax == nuvzmax) .AND. &
+&                   (temp_nwzmax == nwzmax) ) THEN
+                CONTINUE
+            ELSE
+                PRINT *, 'Incompatible dimensions between fp file and current FLEXPART!'
+                PRINT *, '                  FP file     Compiled FP'
+                PRINT *, 'nxmax:     ', temp_nxmax, '    ', nxmax 
+                PRINT *, 'nymax:     ', temp_nymax, '    ', nymax 
+                PRINT *, 'nzmax:     ', temp_nzmax, '    ', nzmax 
+                PRINT *, 'nuvzmax:     ', temp_nuvzmax, '    ', nuvzmax 
+                PRINT *, 'nwzmax:     ', temp_nwzmax, '    ', nwzmax
+                STOP
+            END IF
+
+
+
+
+            ! Scalar values
             READ(iounit) nx, ny, nxmin1, nymin1, nxfield
             READ(iounit) nuvz, nwz, nz, nmixz, nlev_ec
             READ(iounit) dx, dy, xlon0, ylat0, dxconst, dyconst
-#endif
-
-
-
-            ! Get the varid , then read into scalar variable
-            ncret = nf90_inq_varid(ncid, 'nx', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, nx)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'ny', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, ny)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'nxmin1', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, nxmin1)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'nymin1', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, nymin1)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'nxfield', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, nxfield)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'nuvz', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, nuvz)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'nwz', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, nwz)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'nz', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, nz)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'nmixz', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, nmixz)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'nlev_ec', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, nlev_ec)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'dx', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, dx)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'dy', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, dy)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'xlon0', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, xlon0)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'ylat0', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, ylat0)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'dxconst', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, dxconst)
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'dyconst', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, dyconst)
-            call handle_nf90_err(ncret)
-
-
-
-
-
-
-            ! Fixed fields, static in time
-            
-#ifdef RAWBIN            
+
+
+
+
+
+            ! Fixed fields, static in time           
             READ(iounit) oro, excessoro, lsm, xlanduse, height
-#endif
-
-            ncret = nf90_inq_varid(ncid, 'oro', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, oro(0:nxmax-1,0:nymax-1))
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'excessoro', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, excessoro(0:nxmax-1,0:nymax-1))
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'lsm', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, lsm(0:nxmax-1,0:nymax-1))
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'xlanduse', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, xlanduse(0:nxmax-1,0:nymax-1, 1:numclass))
-            call handle_nf90_err(ncret)
-
-            ncret = nf90_inq_varid(ncid, 'height', ncvarid)
-            call handle_nf90_err(ncret)
-            ncret = nf90_get_var(ncid, ncvarid, height(1:nzmax))
-            call handle_nf90_err(ncret)
-
 
 
 
             ! 3d fields
-
-
-
-#ifdef RAWBIN
             READ(iounit) uu(:,:,:,cm_index)
             READ(iounit) vv(:,:,:,cm_index)
